import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:http/http.dart';
import 'package:test_sa/controllers/api_routes/api_manager.dart';
import 'package:test_sa/controllers/api_routes/urls.dart';
import 'package:test_sa/models/device/device.dart';
import 'package:test_sa/models/lookup.dart';
import 'package:test_sa/models/user.dart';

class DevicesProvider extends ChangeNotifier {
  //reset provider data
  void reset() {
    _devices = [];
    _stateCode = null;
  }

  final pageItemNumber = 10;
  bool nextPage = true;
  // state code of current request to defied error message
  // like 400 customer request failed
  // 500 service not available
  int _stateCode;
  int get stateCode => _stateCode;

  List<Device> _devices=[];
  List<Device> get devices => _devices;

  // when categories in-process _loading = true
  // done _loading = true
  // failed _loading = false
  bool _loading;
  bool get isLoading => _loading;
  set isLoading(bool isLoading) {
    _loading = isLoading;
    notifyListeners();
  }

  /// return -2 if request in progress
  /// return -1 if error happen when sending request
  /// return state code if request complete may be 200, 404 or 403
  /// for more details check http state manager
  /// lib\controllers\http_status_manger\http_status_manger.dart
  Future<int> getEquipment({
    @required String host,
    @required User user,
    @required int hospitalId,
    String serialNumber,
    String number,
  }) async {
    if (_loading == true) return -2;
    _loading = true;
    notifyListeners();
    Response response;
    try {
      response = await ApiManager.instance.post(URLs.getEquipment, body: {
        "pageSize": pageItemNumber ,
        "pageNumber":devices.length ~/ pageItemNumber + 1,
        "siteId": hospitalId,
        if (serialNumber?.isEmpty == false) "assetSerialNumber": serialNumber,
        if (number?.isEmpty == false) "assetNo": number,
      });
    } catch (error) {
      _loading = false;
      _stateCode = -1;
      notifyListeners();
      return -1;
    }
    _stateCode = response.statusCode;
    if (response.statusCode >= 200 && response.statusCode < 300) {
      // client's request was successfully received
      List equipmentListJson = json.decode(response.body)["data"];
      _devices.addAll(equipmentListJson.map<Device>((device) => Device.fromJson(device)).toList());
      nextPage = true;
    }else
      {
        nextPage = false;
      }
    _loading = false;
    notifyListeners();
    return response.statusCode;
  }

  /// return -2 if request in progress
  /// return -1 if error happen when sending request
  /// return state code if request complete may be 200, 404 or 403
  /// for more details check http state manager
  /// lib\controllers\http_status_manger\http_status_manger.dart
  Future<List<Device>> getDevicesList({
    @required String host,
    @required User user,
    @required int hospitalId,
    String serialNumber,
    String number,
  }) async {
    Response response;
    try {
      response = await ApiManager.instance.post(URLs.getEquipment, body: {
        "pageSize": pageItemNumber,
        "pageNumber":devices.length ~/ pageItemNumber + 1,
        "siteId": devices.length ~/ pageItemNumber + 1,
        if (serialNumber?.isEmpty == false) "assetSerialNumber": serialNumber,
        if (number?.isEmpty == false) "assetNo": number,
      });
      // response = await get(
      //     Uri.parse("$host${URLs.getEquipment}?siteId=$hospitalId"
      //         "${serialNumber?.isEmpty == false ? "&assetSerialNumber=$serialNumber" :""}"
      //         "${number?.isEmpty == false ? "&assetNo=$number" : ""}"
      //     ),
      // );
      List<Device> page = [];
      if (response.statusCode >= 200 && response.statusCode < 300) {
        // client's request was successfully received
        List equipmentListJson = json.decode(response.body)["data"];
        page = equipmentListJson.map((device) => Device.fromJson(device)).toList();
        _devices.addAll(equipmentListJson.map<Device>((device) => Device.fromJson(device)).toList());
        notifyListeners();
      }
      return page;
    } catch (error) {
      return [];
    }
  }

  Future<List<Lookup>> getModels({
    String code,
  }) async {
    Response response;
    try {
      response = await ApiManager.instance.get(
        URLs.getModels + "?code=$code",
      );
      List<Lookup> page = [];
      if (response.statusCode >= 200 && response.statusCode < 300) {
        // client's request was successfully received
        List categoriesListJson = json.decode(response.body)["data"];
        page = categoriesListJson
            .map((json) => Lookup(
                  name: json["modelDefCode"],
                  id: json["id"],
                  value: json["id"],
                ))
            .toList();
      }
      return page;
    } catch (error) {
      return [];
    }
  }

  /// return -2 if request in progress
  /// return -1 if error happen when sending request
  /// return state code if request complete may be 200, 404 or 403
  /// for more details check http state manager
  /// lib\controllers\http_status_manger\http_status_manger.dart
  Future<List<Device>> getDevicesListBySN({@required String host, @required User user, @required int hospitalId, @required String sn}) async {
    Response response;
    try {
      response = await get(
        Uri.parse(URLs.getEquipment + "?client=$hospitalId" + (sn == null || sn.isEmpty ? "" : "&serial_qr=$sn")),
      );

      _stateCode = response.statusCode;
      List<Device> _page = [];
      if (response.statusCode >= 200 && response.statusCode < 300) {
        // client's request was successfully received
        List categoriesListJson = json.decode(utf8.decode(response.bodyBytes));
        _page = categoriesListJson.map((device) => Device.fromJson(device)).toList();
      }
      return _page;
    } catch (error) {
      _loading = false;
      _stateCode = -1;
      notifyListeners();
      return [];
    }
  }
}
